"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _Visitor = require("./Visitor");

var _Visitor2 = _interopRequireDefault(_Visitor);

var _FileUtility = require("../util/FileUtility");

var _FileUtility2 = _interopRequireDefault(_FileUtility);

var _ReactTransformer = require("../docs/react/ReactTransformer");

var _ReactTransformer2 = _interopRequireDefault(_ReactTransformer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Transformer = function Transformer() {
    var _this = this;

    _classCallCheck(this, Transformer);

    this.pre = function (source) {
        if (!_this.root) {
            _this.root = source.opts.sourceRoot;
            var configSource = _FileUtility2.default.toString(_this.root + "/.doc.gen.json");
            _this.config = JSON.parse(configSource);
            if (_this.config.react) {
                _this.config.react.root = _this.root;
                _this.reactTransformer = new _ReactTransformer2.default(_this.config.react);
            }
        }

        var fileInformation = _FileUtility2.default.getInformation(source.opts.filename);

        if (_this.reactTransformer) {
            _this.reactTransformer.transform(fileInformation, source.code);
        }
    };
};

exports.default = new Transformer();